/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package kamennuzkypapir;

import java.util.*;

/**
 *
 * @author Dana Nejedlová <dana.nejedlova at tul.cz>
 */
public class Hra {

    static Scanner scanner = new Scanner(System.in);
    static Random random = new Random();

    public void hraj() {
        int indexPocitace, indexCloveka, pocetKol, skore = 0;
        Tah[] tahy = Tah.values();
        System.out.println("Vítejte ve hře Kámen, nůžky, papír.");
        pocetKol = zadejCeleCislo("Kolik chcete hrát kol? ");
        System.out.println("Každá prohra odečte jeden bod a každá výhra jeden bod přičte.");
        for (int i = 1; i <= pocetKol; i++) {
            indexCloveka = tahCloveka(tahy);
            indexPocitace = tahPocitace(tahy);
            skore += tahy[indexCloveka].porovnej(tahy[indexPocitace]);
            System.out.println("V " + i + ". kole je skóre " + skore + ".");
        }
    }

    private int tahPocitace(Tah[] tahy) {
        int index = random.nextInt(tahy.length);
        System.out.println("Počítač zvolil " + tahy[index].toString() + ".");
        return index;
    }

    private int tahCloveka(Tah[] tahy) {
        int index;
        while (true) {
            try {
                for (int i = 0; i < tahy.length;i++){
                    System.out.println(i + " " + tahy[i].name());
                }
                System.out.print("Zadej 0 až " + (tahy.length - 1) + ": ");
                index = scanner.nextInt();
                scanner.nextLine();
                System.out.println("Ty jsi zvolil " + tahy[index].toString() + ".");
                break;
            } catch (InputMismatchException e) {
                System.out.println("To není celé číslo!");
                scanner.nextLine();
            } catch (IndexOutOfBoundsException e) {
                System.out.println("Číslo není v rozsahu 0 až " + (tahy.length - 1) + "!");
            }
        }
        return index;
    }

    private int zadejCeleCislo(String vyzva) {
        int cislo;
        while (true) {
            try {
                System.out.print(vyzva);
                cislo = scanner.nextInt();
                scanner.nextLine();
                break;
            } catch (InputMismatchException e) {
                System.out.println("To není celé číslo!");
                scanner.nextLine();
            }
        }
        return cislo;
    }
}
