/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package kamennuzkypapir;

/**
 *
 * @author Dana Nejedlová <dana.nejedlova at tul.cz>
 */
public enum Tah {

    KAMEN(" tupí ") {

        @Override
        public Tah porazi() {
            return NUZKY;
        }
    },
    NUZKY(" stříhají ") {

        @Override
        public Tah porazi() {
            return PAPIR;
        }
    },
    PAPIR(" balí ") {

        @Override
        public Tah porazi() {
            return KAMEN;
        }
    };
    final int WIN = 1;
    final int TIE = 0;
    final int LOOSE = -1;

    public abstract Tah porazi();
    private final String coDela;

    Tah(String coDela) {
        this.coDela = coDela;
    }

    public int porovnej(Tah protihrac) {

        if (this == protihrac) {
            System.out.println("Remíza");
            return TIE;
        } else if (protihrac == this.porazi()) {
            return vitezstvi(protihrac);
        } else {
            return prohra(protihrac);
        }
    }

    int vitezstvi(Tah protihrac) {
        System.out.println(this.toString() + this.coDela + protihrac.toString() + ".");
        System.out.println("Vyhrál jsi.");
        return WIN;
    }

    int prohra(Tah protihrac) {
        System.out.println(protihrac.toString() + protihrac.coDela + this.toString() + ".");
        System.out.println("Prohrál jsi.");
        return LOOSE;
    }
}
